//!
//! @file mc_control.c,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief {͒JԂ񋟂܂B
//! ` : PI͔ƐϕӖ܂B
//!
//! @version 1.3
//!
#include "config.h"
#include "inavr.h"

/* xϐ */
S16 speed_error=0;				//!< JԂ덷vZ
S16 speed_integral = 0;			//!< Ǐϕl
S16 speed_integ = 0;			//!< Ԑϕl
S16 speed_proportional = 0;		//!< Ǐl

/************************************************************************************************************/
/*												x													*/
/************************************************************************************************************/
/**
* @brief x䕔
* @return x̒l(16ޯĂޭè )
*		  speed_measure10ޯĕ\܂B
*/
U16 mc_control_speed_16b(U16 speed_ref , U16 speed_measure)
{
  U16 result = 0;
  S16 increment = 0;

  // 덷vZ
//  speed_error = speed_ref - speed_measure/2 ;
  speed_error = speed_ref - speed_measure;

  // ፀvZ : Kp= 7/64=0.1
  speed_proportional = speed_error * 4;

  // ϕvZ
  speed_integral = speed_integral + speed_error;

  // xϕOa
  if(speed_integral >  32000) speed_integral =  32000;
  if(speed_integral < -32000) speed_integral = -32000;

  speed_integ = (speed_integral - speed_integral/8 + speed_integral/32) / 16 ;

  // vZ
  increment = speed_proportional + speed_integ;

  // PIo̖͂Oa
  if (increment > 0)
  {
	if  (increment <= (S16)(MAX_AMPLITUDE)) result = (S16)increment ;
	else result = MAX_AMPLITUDE ;
  }
  else result = 0;

  // ޭè قԂB
  return result;
}
