//!
//! @file mc_interface.h,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief ͯޕ͓d@p̍ʊ֐񋟂܂B
//!
//! @version 1.3
//!

#ifndef _MC_LIB_H_
#define _MC_LIB_H_

extern Bool mci_direction;
extern volatile Bool mci_run_stop;

//void mci_motor_run(void);
Bool mci_motor_is_running(void);

void mci_set_motor_speed(U8 speed);

void mci_set_direction(U8 direction);
U8 mci_get_direction(void);
#define mci_get_motor_direction() mci_direction

void mci_store_measured_speed(U8 measured_speed);
U8 mci_get_measured_speed(void);

U16 mci_get_measured_current(void);
void mci_store_measured_current(U16 current);

void mci_run(void);
void mci_stop(void);

void mci_forward(void);
void mci_backward(void);
void mci_set_speed(U16);

#endif
